unit KronosNO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Kronos;

type
  TKronosNO = class(TKronos)
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure SetCountrySpecifics; override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent);override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TKronosNO]);
end;

procedure TKronosNO.SetCountrySpecifics;
var
   DT : TDaytypeDef;
begin
   SpecifyStandardDay(chAdvent1,'1. s. i advent', true, false);
   SpecifyStandardDay(chAdvent2, '2. s. i advent', true, false);
   SpecifyStandardDay(chAdvent3, '3. s. i advent', true, false);
   SpecifyStandardDay(chAdvent4, '4. s. i advent', true, false);
   SpecifyStandardDay(chChristmasEve, 'Julaften', false, false);
   SpecifyStandardDay(chChristmasDay, '1. juledag', true, true);
   SpecifyStandardDay(chBoxingDay, '2. juledag', true, false);
   SpecifyStandardDay(chNewYearEve, 'Nyttrsaften', false, false);
   SpecifyStandardDay(chNewYearDay, 'Nyttrsdag', true, true);
   SpecifyStandardDay(chShroveTuesDay, 'Fetetirsdag', false, false);
   SpecifyStandardDay(chAshWednesday, 'Askeonsdag', false, false);
   SpecifyStandardDay(chPalmSunday, 'Palmesndag', true, false);
   SpecifyStandardDay(chMaundyThursday, 'Skjrtorsdag', true, false);
   SpecifyStandardDay(chGoodFriday, 'Langfredag', true, false);
   SpecifyStandardDay(chEasterEve, 'Pskeaften', false, false);
   SpecifyStandardDay(chEasterSunday, '1. pskedag', true, true);
   SpecifyStandardDay(chEasterMonday, '2. pskedag', true, false);
   SpecifyStandardDay(chWhitEve, 'Pinseaften', false, false);
   SpecifyStandardDay(chWhitSunday, '1. pinsedag', true, true);
   SpecifyStandardDay(chWhitMonday, '2. pinsedag', true, false);
   SpecifyStandardDay(chAscensionDay, 'Kr. himmelfartsdag', true, false);

   SpecifyStandardDay(coMayDay, '1. mai', true, true);
   SpecifyStandardDay(coUNDay, 'FN-dagen', false, false);
   SpecifyStandardDay(coWomensDay, 'Kvinnedagen', false, false);
   SpecifyStandardDay(coLiteracyDay, 'Int. litteraturdag', false, false);

   with DT do
   begin
        AName := 'Blmandag';
        ADate := 0;
        ARelDaytype := chEasterSunday;
        AnOffset := -48;
        AFirstShowUp := 1;
        ALastShowUp := 9999;
        AShowUpFrequency := 1;
        AChurchday := false;
        AHoliday := false;
        AFlagday := false;
        AUserCalc := false;
        ATag := 0;
        AddDaytype(TDaytype.Create(DT));

        AName := 'Frigjringsdag';
        ADate := 508;
        ARelDaytype := 0;
        AnOffset := 0;
        AFlagDay := true;
        AFirstShowUp := 1945;
        AddDaytype(TDaytype.Create(DT));

        AName := 'Grunnlovsdag';
        ADate := 517;
        AFirstShowup := 1814;
        AHoliday := true;
        AddDaytype(TDaytype.Create(DT));

        AName := 'St. Hansaften';
        ADate := 624;
        AFirstShowup := 1;
        AHoliday := false;
        AFlagday := false;
        AddDaytype(TDaytype.Create(DT));

        AName := 'Olsok';
        ADate := 729;
        AFirstShowup := 1000;
        AHoliday := false;
        AFlagday := true;
        AChurchday := true;
        AddDaytype(TDaytype.Create(DT));

        AName := 'Unionsopplsningen';
        ADate := 607;
        AFirstShowup := 1905;
        AFlagday := true;
        AChurchday := false;
        AddDaytype(TDaytype.Create(DT));
   end;

end;

constructor TKronosNO.Create;
begin
     inherited Create(AOwner);
     FirstWeekDay := Monday;
     WeekHolidays := [Sunday];
end;


end.
