unit AVITestU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MPlayer, ExtCtrls, ComCtrls;

type
  TfrmAVIResource = class(TForm)
    Animate1: TAnimate;
    Panel1: TPanel;
    MediaPlayer1: TMediaPlayer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAVIResource: TfrmAVIResource;

implementation

uses
  MMSystem;

{$R *.DFM}
{$R VidRes.Res}

const
  ResName = 'Cool';

var
  FileName: String;

procedure TfrmAVIResource.Button1Click(Sender: TObject);
begin
  Animate1.ResName := ResName;
  Animate1.Active := True;
end;

procedure TfrmAVIResource.Button2Click(Sender: TObject);
var
  Buf: array[0..Max_Path] of Char;
  FS: TFileStream;
  RS: TResourceStream;
begin
  RS := TResourceStream.Create(HInstance, ResName, 'AVI');
  try
    Win32Check(Bool(GetTempPath(SizeOf(Buf), Buf)));
    FileName := StrPas(Buf) + ResName + '.AVI';
    MediaPlayer1.Close;
    FS := TFileStream.Create(FileName, fmCreate);
    try
      FS.CopyFrom(RS, 0)
    finally
      FS.Free
    end;
    MediaPlayer1.FileName := FileName;
    MediaPlayer1.Open;
    MediaPlayer1.Play;
  finally
    RS.Free
  end
end;

procedure TfrmAVIResource.FormDestroy(Sender: TObject);
begin
  DeleteFile(FileName)
end;

procedure TfrmAVIResource.Button3Click(Sender: TObject);
begin
  PlaySound('Ding', HInstance, snd_Resource or snd_Sync);
end;

procedure TfrmAVIResource.Button4Click(Sender: TObject);
begin
  with TResourceStream.Create(HInstance, 'Ding', 'WAVE') do
    try
      SndPlaySound(Memory, snd_Memory or snd_Sync);
    finally
      Free
    end
end;

end.
