unit GridMovU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, Grids, DBGrids, DB, DBTables, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    btnUp: TSpeedButton;
    btnRight: TSpeedButton;
    btnDown: TSpeedButton;
    btnLeft: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure btnUpAndDownClick(Sender: TObject);
    procedure btnLeftAndRightClick(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  public
    { Local object references }
    Grid: TDBGrid;
    DataSet: TDataSet;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Set up some local object ref.s for convenience }
  Grid := DBGrid1;
  if Grid.DataSource <> nil then
    DataSet := Grid.DataSource.DataSet
end;

procedure TForm1.btnUpAndDownClick(Sender: TObject);
begin
  { Both up and down buttons share this event handler }
  { Move field pointer up or down one record }
  DataSet.MoveBy(TComponent(Sender).Tag)
end;

procedure TForm1.btnLeftAndRightClick(Sender: TObject);
begin
  { Both left and right buttons share this event handler }
  { Move field pointer left or right one field }
  Grid.SelectedIndex := Grid.SelectedIndex + TComponent(Sender).Tag
end;

procedure TForm1.DBGrid1ColEnter(Sender: TObject);
begin
  { When moving from field to field, enable/disable buttons as appropriate }
  btnLeft.Enabled := Grid.SelectedIndex > 0;
  btnRight.Enabled := Grid.SelectedIndex < Grid.FieldCount - 1;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  { When moving from record to record, enable/disable buttons as appropriate }
  btnUp.Enabled := not TDataSource(Sender).DataSet.BOF;
  btnDown.Enabled := not TDataSource(Sender).DataSet.EOF;
end;

end.
