unit VidU1;

interface

uses
{$ifdef Win32}
  ComCtrls,
{$endif}
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, Menus, ExtCtrls;

type
  TfrmMain = class(TForm)
    Media: TMediaPlayer;
    dlgOpen: TOpenDialog;
    mnuMainMenu: TMainMenu;
    mnuFile: TMenuItem;
    mnuOpen: TMenuItem;
    mnuFullScreen: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure mnuFullScreenClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MediaClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
  private
  end;

var
  frmMain: TfrmMain;

implementation

uses VidU2, VidU3;

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
{$ifdef Win32}
  BorderStyle := bsToolWindow;
{$endif}
end;

procedure TfrmMain.mnuOpenClick(Sender: TObject);
begin
  if dlgOpen.Execute then
  begin
    { Open file of user's choice }
    Media.FileName := dlgOpen.FileName;
    Media.Open;
  end
end;

procedure TfrmMain.mnuFullScreenClick(Sender: TObject);
begin
  with (Sender as TMenuItem) do
  begin
    { Toggle menu item check mark }
    Checked := not Checked;
    { Set the media player's output to panel on appropriate form }
    if Checked then
      Media.Display := frmDisplayFull.pnlDisplay
    else
      Media.Display := frmDisplay.pnlDisplay;
    { Show other form, if a video is playing }
    if Media.Mode = mpPlaying then
    begin
      frmDisplayFull.Visible := Checked;
      frmDisplay.Visible := not Checked
    end
  end
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  { Closing main form terminates app }
  Close
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := MessageDlg('Close multimedia player?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes
end;

procedure TfrmMain.MediaClick(Sender: TObject; Button: TMPBtnType;
  var DoDefault: Boolean);
begin
  if (Button = btPlay) and (Media.Mode = mpStopped) then
  begin
    { Display apropriate video display window, & hide the other }
    { Ensuring the OnShow event triggers to resize the video }
    frmDisplayFull.Hide;
    frmDisplay.Hide;
    frmDisplayFull.Visible := mnuFullScreen.Checked;
    frmDisplay.Visible := not mnuFullScreen.Checked;
  end
end;

end.
