unit VidU2;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TfrmDisplay = class(TForm)
    pnlDisplay: TPanel;
    procedure pnlDisplayResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure pnlDisplayClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDisplay: TfrmDisplay;

implementation

uses VidU1;

{$R *.DFM}

procedure TfrmDisplay.pnlDisplayResize(Sender: TObject);
begin
  { Make video display fit nice and snugly in form }
  frmMain.Media.DisplayRect := (Sender as TPanel).BoundsRect
end;

procedure TfrmDisplay.FormShow(Sender: TObject);
begin
  { Ensure video output is right size from the start }
  pnlDisplay.OnResize(pnlDisplay)
end;

procedure TfrmDisplay.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if MessageDlg('Close multimedia player?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    Application.Terminate
end;

procedure TfrmDisplay.pnlDisplayClick(Sender: TObject);
begin
  { A mouse click brings controls back }
  frmMain.Show
end;

procedure TfrmDisplay.FormCreate(Sender: TObject);
begin
  frmMain.Media.Display := pnlDisplay
end;

end.
