unit VidU3;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TfrmDisplayFull = class(TForm)
    pnlDisplay: TPanel;
    procedure pnlDisplayResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pnlDisplayClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDisplayFull: TfrmDisplayFull;

implementation

uses VidU1;

{$R *.DFM}

procedure TfrmDisplayFull.pnlDisplayResize(Sender: TObject);
begin
  { Make video display fit nice and snugly in form }
  frmMain.Media.DisplayRect := (Sender as TPanel).BoundsRect
end;

procedure TfrmDisplayFull.FormShow(Sender: TObject);
begin
  { Ensure video output is right size from the start }
  pnlDisplay.OnResize(pnlDisplay)
end;

procedure TfrmDisplayFull.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  { Alt-F4 is same as Alt-F, F, i.e. turn off full-screen mode }
  frmMain.mnuFullScreen.Click
end;

procedure TfrmDisplayFull.pnlDisplayClick(Sender: TObject);
begin
  { A mouse click brings controls back }
  frmMain.Show
end;

end.
